using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace BlackHole
{
	class NotifyingQueue
	{
		private const int SIZE = 10;
		private Object[]  queue = new Object[SIZE];
		private int       head  = 0;
		private int       tail  = 0;
	
		public void enqueue( Object item ) {
			lock (this)
			{
				head++;
				head %= SIZE;
				queue[head] = item;
				Monitor.Pulse(this);
			}
		}
	                                   
		public Object dequeue() {
			lock (this)
			{
				while (head == tail) //do not use IF here!!
				{
					Monitor.Wait(this);
				}
				tail++;
				tail %= SIZE;
				return queue[tail];
			}
		}
	}
}
