using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Runtime.Remoting.Messaging;

namespace Fibonacci
{
    class FiboService : ICallbackHandle
	{
        public delegate BigInteger FiboDelegate(int value);
        private FiboDelegate del;

        public FiboService()
        {
        }

		public void Request()
		{
			Console.Write("Eingabe ? ");
			String line = Console.ReadLine();
            if (line != "")
            {
                int n = Convert.ToInt32(line);
                FibonacciHandler fiboHandler = new FibonacciHandler(this);

                //VARIANTE 1:
                //Thread fiboThread = new Thread(() => fiboHandler.Calc(n));
                //fiboThread.Start();

                //VARIANTE 1.1: new Thread(fiboHandler.Calc).Start(n);

                //VARIANTE 2:
                this.del = new FiboDelegate(fiboHandler.GetFibonacci);
                AsyncCallback callback = new AsyncCallback(Handle);
                IAsyncResult res = del.BeginInvoke(n, callback, null);

                /*
                for (int i = 0; i < 10; i++)
                {
                    Console.WriteLine("ttt....");
                    Thread.Sleep(1000);
                }*/
            }
		}

        public void Handle(object result)
        {
            lock (this)
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("Callback: " + (BigInteger)result);
                Console.ForegroundColor = ConsoleColor.Gray;
            }

        }

        public void Handle(IAsyncResult ar)
        {
            var del = (FiboDelegate)((AsyncResult)ar).AsyncDelegate;

            lock (this)
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("Callback: " + (BigInteger)del.EndInvoke(ar));
                Console.ForegroundColor = ConsoleColor.Gray;
            }
        }

		public static void Main()
		{
			FiboService service = new FiboService();
			while (true)
			{
				service.Request();
			}
		}
	}
}
