using System;
using System.Collections.Generic;
using System.Text;

namespace Fibonacci
{
    class FibonacciDelegate
	{

        private ICallbackHandle service;

        public FibonacciDelegate(ICallbackHandle service)
        {
            this.service = service;
        }

        public void Calc(object value)
        {
            BigInteger result = GetFibonacci((int)value);
            service.Handle(result);
        }

		public BigInteger GetFibonacci(int value)
		{
			BigInteger n = new BigInteger(value);
			BigInteger zero = new BigInteger(0);
			BigInteger one = new BigInteger(1);
            if (n == zero)
                return zero;
			if (n == one)
                return one;
			BigInteger i = one;
			BigInteger a = zero;
			BigInteger b = one;
			while (i < n) {
				BigInteger temp = b;
				b = a+b; 
				a = temp;
				i++;
			}
            return b;
		}
	}
}
