﻿using System;
using System.Threading;

public class Fibonacci
{
    public int N { get { return n; } }
    private int n;

    public int FibOfN { get { return fibOfN; } }
    private int fibOfN;

    private ManualResetEvent doneEvent;

    private readonly object colorLock = new object();

    public Fibonacci(int n, ManualResetEvent doneEvent)
    {
        this.n = n;
        this.doneEvent = doneEvent;
    }

    // Wrapper method for use with thread pool.
    public void ThreadPoolCallback(Object threadContext)
    {
        int threadIndex = (int)threadContext;
        lock (colorLock)
        {
            Console.ForegroundColor = (ConsoleColor)((threadIndex % 14) + 1);
            Console.WriteLine("Thread {0} started.", threadIndex);
        }
        
        //Calculate fibonacci
        fibOfN = Calculate(n);

        lock (colorLock)
        {
            Console.ForegroundColor = (ConsoleColor)((threadIndex % 14) + 1);
            Console.WriteLine("Thread {0} finished.", threadIndex);
        }
        doneEvent.Set();
    }

    // Recursive method that calculates the Nth Fibonacci number.
    public int Calculate(int n)
    {
        if (n <= 1)
        {
            return n;
        }

        return Calculate(n - 1) + Calculate(n - 2);
    }

}
