using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace LostSignals
{
	class Worker
	{
		private ISynch signal;
		private Operator op;
        private int id;
        private static readonly object colorLock = new object();

		public Worker(ISynch signal, Operator op, int id)
		{
			this.signal = signal;
			this.op = op;
            this.id = id;
		}

		public void Do()
		{
			while (true)
			{
				signal.Acquire();
                lock (colorLock)
                {
                    Console.ForegroundColor = (ConsoleColor)id + 5;
                    Console.WriteLine("Worker " + id + " released...");
                }
				Thread.Sleep(op.Operation());
				op.Done(id);
			}
		}
	}
}
