﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Mandelbrot
{
    class Line : IEnumerator, IEnumerable
    {
        private Point[] line;
        int position = -1;
        int enumposition = -1;
        private int size = 0;
        private int index = 0;

        public int Length
        {
            get { return position; }
        }

        public Line(int index, int size)
        {
            this.size = size;
            this.index = index;
            line = new Point[size];
        }

        public void AddPoint(Point point)
        {
            lock (this)
            {
                line[++position] = point;
            }
        }

        //Implement IEnumerable
        public IEnumerator GetEnumerator()
        {
            return (IEnumerator)this;
        }

        public bool MoveNext()
        {
            enumposition++;
            return (enumposition < line.Length);
        }

        public void Reset()
        { enumposition = 0; }

        public object Current
        {
            get { return line[enumposition]; }
        }

        




    }
}
