﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Drawing;

namespace Mandelbrot
{
    class MandelbrotHandler : ICallbackHandler
    {
        private ICallbackHandler handler;
        private ManualResetEvent doneEvent;
        private Line line;
        private int nSections;
        private int j;
        private double a;
        private double b;
        private double step;

        public MandelbrotHandler(ICallbackHandler handler, int nSections, int j, double a, double b, double step/*, ManualResetEvent doneEvent*/)
        {
            this.handler = handler;
            //this.doneEvent = doneEvent;
            this.line = new Line(j, nSections);
            this.nSections = nSections;
            this.j = j;
            this.a = a;
            this.b = b;
            this.step = step;
        }

        public void Run(Object threadContext)
        {
            for (int k = 0; k < nSections; k++)
            {
                b += step;
                MandelbrotMenge mm = new MandelbrotMenge(this, a, b, j, k);
                //new Thread(mm.Calc).Start();
                mm.Calc(null);
                //doneEvent.Set();
            }
            
        }

        public void handle(Object res)
        {
            Point point = (Point)res;
            lock (this)
            {
                if (point != null)
                {
                    line.AddPoint(point);
                }

                if (line.Length == nSections - 1)
                {
                    handler.handle(line);
                    //doneEvent.Set();

                }
            }

        }

    }
}
