using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Threading;

namespace Mandelbrot
{
	class MandelbrotMenge
	{
		private ICallbackHandler fractal;
		private double a, b;
		private int j, k;
		private const int deep = 500;

        public MandelbrotMenge(ICallbackHandler fractal, double a, double b, int j, int k)
		{
			this.fractal = fractal;
			this.a = a;
			this.b = b;
			this.j = j;
			this.k = k;
		}

        public void Calc(Object threadContext)
        {
			double xx, x, y;
			int n;
			x = y = xx = n = 0;
			while (n < deep && (x * x + y * y) < 4) {
				xx = x * x - y * y + a;
				y = 2 * x * y + b;
				x = xx;
				n++;
			}
			if (fractal != null)
            {
				Int32 color = -Int32.MaxValue/deep*n;
				if (n == deep)
                {
					color = 0;
				}
				Point point;
				point = new Point(j, k, color);
				fractal.handle(point);
			}
		}
	}
}
