using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Parkhaus
{
	class Parkhaus
	{
        private Semaphore semaphore;
        private readonly object nLock = new object();
		private int n;

		public Parkhaus(int p)
		{
            semaphore = new Semaphore(p, p);
            n = p; // kein lock notwendig!!
		}

		public void Passieren()
		{
            semaphore.WaitOne();
            lock (this)
            {
                n--; //Platz abziehen
            }
		}

		public void Verlassen()
		{
            lock (this)
            {
                n++;                    //1.) Freier Platz bekannt geben
                semaphore.Release(1);   //2.) 1 Auto verlsst den Parkplatz
            }
		}

		public int AnzahlPlaetze()
		{
            lock (this)
            {
                return n;
            }
		}
	}
}
