﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Parkhaus
{
    class Program
    {
        private static readonly object writeLock = new object();
        private static int maxCars = 40;
        private static int maxSlots = 10;

        public static void Main()
        {
            Parkhaus parkhaus = new Parkhaus(maxSlots);
            for (int i = 1; i <= maxCars; i++)
            {
                Auto auto = new Auto(i, parkhaus);
                new Thread(auto.Drive).Start();
            }
        }

        /// <summary>
        /// Coloured console output method
        /// </summary>
        /// <param name="message">Message to be written to console</param>
        /// <param name="id">ID (e.g. of a particular thread) to calculate color</param>
        public static void WriteConsole(string message, int id)
        {
            lock(writeLock)
            {
                Console.ForegroundColor = (ConsoleColor)(id % 14 + 1);
                Console.WriteLine(message);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
        }
    }
}
