
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Threading;

namespace Generator
{
    public class RandomCounter
    {
        static Mutex mutex = new Mutex(false, "OnlyOneAtATime");

        public static void Main()
        {
            Random rnd = new Random();
            Console.WriteLine("Generator");
            try
            {
                //http://stackoverflow.com/questions/222089/in-c-if-2-processes-are-reading-and-writing-to-the-same-file-what-is-the-best
                using(FileStream fs = File.Open("daten.txt", FileMode.Create, FileAccess.ReadWrite, FileShare.Read))
                using(StreamWriter sw = new StreamWriter(fs))
                {
                    int n = rnd.Next(5000);
                    for (int i = 0; i < n; i++)
                    {
                        mutex.WaitOne();
                        try
                        {
                            int numberRange = 1000;
                            int number = rnd.Next(numberRange);
                            sw.WriteLine(number);

                            Console.ForegroundColor = (ConsoleColor)(number % 14 +1);
                            Console.Write(".");
                            Console.ForegroundColor = ConsoleColor.Gray;

                            Thread.Sleep(100); //Wait 100ms //Just for simulation
                        }
                        catch (ApplicationException appex)
                        {
                            Console.WriteLine();
                            Console.ForegroundColor = ConsoleColor.Red;
                            Console.Write(appex.Message);
                            Console.ForegroundColor = ConsoleColor.Gray;
                        }
                        finally
                        {
                            sw.Flush(); //Write cache down to the file system
                            fs.Flush(); //before releasing critical section
                            mutex.ReleaseMutex();
                        }
                    }
                }
            }
            catch (AbandonedMutexException)
            {
                Console.WriteLine();
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine("The exception that is thrown when one thread acquires a Mutex object"
                                + "that another thread has abandoned by exiting without releasing it.");
                Console.ForegroundColor = ConsoleColor.Gray;
            }

            catch (Exception ex)
            {
                Console.WriteLine();
                Console.ForegroundColor = ConsoleColor.Red;
                Console.Write(ex.StackTrace);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("Finished");
            Console.ReadLine();
        }
    }
}
