using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Threading;

namespace MinMax
{
    class MinMaxNumber
    {
        public MinMaxNumber()
        {
            Main();
        }

        static Mutex mutex = new Mutex(false, "OnlyOneAtATime");

        static void Main()
        {
            int min = 0;
            int max = 0;
            int sum = 0;
            int count = 0;
            
            try
            {
                FileStream fs = new FileStream("daten.txt", FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
                StreamReader sr = new StreamReader(fs);

                while (true)
                {

                    mutex.WaitOne(); //Enter critical section

                    string line = string.Empty;

                    if ((line = sr.ReadLine()) == null)
                    {
                        mutex.ReleaseMutex();
                        break; //Exit loop if end of file reached   
                    }

                    try
                    {

                        int num = Int32.Parse(line);
                        count++;
                        sum += num;

                        min = min > num ? num : min;
                        max = max < num ? num : max;
                        //Console.Write(".");
                        Console.Clear();
                        Console.WriteLine("MinMax");
                        Console.WriteLine("Min := " + min);
                        Console.WriteLine("Avg := " + ((float)sum / (float)count));
                        Console.WriteLine("Max := " + max);
                        Thread.Sleep(100); //Wait 100ms //Just for simulation
                    }
                    finally
                    {
                        mutex.ReleaseMutex(); //Exit critical section
                    }
                }
                sr.Close();
                fs.Close();
            }
            catch (AbandonedMutexException)
            {
                Console.WriteLine();
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine("The exception that is thrown when one thread acquires a Mutex object"
                                + "that another thread has abandoned by exiting without releasing it.");
                Console.ForegroundColor = ConsoleColor.Gray;
            }
            catch (ApplicationException appex)
            {
                Console.WriteLine();
                Console.ForegroundColor = ConsoleColor.Red;
                Console.Write(appex.Message);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
            catch (Exception ex)
            {
                Console.WriteLine();
                Console.ForegroundColor = ConsoleColor.Red;
                Console.Write(ex.StackTrace);
                Console.ForegroundColor = ConsoleColor.Gray;
            }

            Console.WriteLine();
            Console.WriteLine("Finished");
            Console.ReadLine();
		}



    }
}
