using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;

namespace Sema
{
	public class Sema : ISynch
	{
        //private EventWaitHandle waitHandle = new ManualResetEvent(false);
        private Queue<EventWaitHandle> waitHandleQueue;
        private int maximumCount = 0;
        private Int32 releaseCount = 0;
        private object locker = new object();

        public Sema(int maximumCount)
        {
            this.maximumCount = maximumCount;
            waitHandleQueue = new Queue<EventWaitHandle>();

            if (maximumCount < 1)
            {
                throw new ArgumentOutOfRangeException("maximumCount", "Argument out of range: Non-negative number required.");
            }
		}


        /*
         
		public void Acquire()
        {
            bool wait = false;
            EventWaitHandle waitHandle = new EventWaitHandle(false, EventResetMode.AutoReset);
            lock(locker)
            {                
                waitHandleQueue.Enqueue(waitHandle);

                if (releaseCount < maximumCount)
                {
                    releaseCount++;
                    wait = false;
                }
                else
                {
                    wait = true;
                }
            }
            if (wait) //Zwingend ausserhalb des locks warten:
            {
                waitHandle.WaitOne(); //Let another thread go...
                lock (locker)
                {
                    releaseCount++;       //and increase the counter
                }
            }
        }

		public void Release()
        {
            lock (locker)
            {
                if (releaseCount > 0)
                {
                    --releaseCount;                  //Minus one executing thread...
                    waitHandleQueue.Dequeue().Set(); //Signal another thread to run
                }
                
            }
        }*/

        public void Acquire()
        {
            lock (locker)
            {
                while (releaseCount >= maximumCount)
                Monitor.Wait(locker);   //Let the thread wait until releaseCount was decreased by another thread.

                releaseCount++;
            }
        }

        public void Release()
        {
            lock (locker)
            {
                if (releaseCount <= maximumCount)
                {
                    //Indicate another thread to continue
                    releaseCount--;
                    Monitor.Pulse(locker);  
                }
            }
        }

	}
}
