using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Sema
{
	class SemaphoreTest
	{
        private static readonly object lockObject = new object();
		static Sema s = new Sema(3);  // Available=3

		static void Main() {
			for (int i = 0; i < 10; i++) {
				new Thread(Go).Start(i);
			} 
		}

		static void Go(object number)
        {
            int colorIndex = Convert.ToInt32(number) % 10 + 5;
			while (true) {
                lock (lockObject)
                {
                    Console.ForegroundColor = (ConsoleColor)colorIndex;
                    Console.WriteLine(number.ToString() + ". Thread waits.");
                    Console.ResetColor();
                }
				s.Acquire();
                lock (lockObject)
                {
                    Console.ForegroundColor = (ConsoleColor)colorIndex;
                    Console.WriteLine(number.ToString() + ". Thread is in critical section");
                    Console.ResetColor();
                }
                Thread.Sleep(3000);   // Only 3 threads can get here at once
				s.Release();
                lock (lockObject)
                {
                    Console.ForegroundColor = (ConsoleColor)colorIndex;
                    Console.WriteLine(number.ToString() + ". Thread leaves.");
                    Console.ResetColor();
                }
			}
		}
	}
}
